Repository: http://svn/svn/xt
URL: http://svn/svn/xt/subsystems/lustre/filesystem/trunk/2.1
Revision: 31313
Date: 12/07/11 17:17:29
Author: wang
Subject: no longer has AUTOCONF_INCLUDED after 2.6.37
Description:
AUTOCONF_INCLUDED has been removed since 2.6.37.
Not sure we still need it, initially created in bz 11802 att. 11752. Temporarily ifdef it with version. May be we should just remove the whole thing.

Inspected by: spitzcor
Product: RS_LUSTRE
Bugs Affected: 778068
Bug Action: UPDATE
Target Branch: Other
Documentation Notes:
n/a
Files affected:
M       libcfs/include/libcfs/linux/kp30.h
M       libcfs/include/libcfs/linux/linux-prim.h
M       libcfs/include/libcfs/linux/linux-time.h
M       libcfs/libcfs/linux/linux-debug.c
M       libcfs/libcfs/linux/linux-prim.c
M       libcfs/libcfs/linux/linux-proc.c
M       lnet/klnds/gnilnd/gnilnd.h
M       lnet/klnds/mxlnd/mxlnd.h
M       lnet/klnds/o2iblnd/o2iblnd.h
M       lnet/klnds/ptllnd/ptllnd.h
M       lnet/klnds/qswlnd/qswlnd.h
M       lnet/klnds/ralnd/ralnd.h
M       lnet/klnds/socklnd/socklnd_lib-linux.h
M       lustre/include/linux/lprocfs_status.h
M       lustre/include/linux/obd_support.h
M       lustre/llite/llite_mmap.c
M       lustre/llite/lloop.c
M       lustre/llite/rw26.c
M       lustre/lvfs/lvfs_linux.c
M       lustre/mdc/mdc_reint.c
M       lustre/mds/mds_log.c
M       lustre/mdt/mdt_identity.c
M       lustre/mdt/mdt_idmap.c
M       lustre/obdclass/linux/linux-module.c
M       lustre/obdfilter/filter.c
M       lustre/obdfilter/filter_io.c
M       lustre/obdfilter/filter_io_26.c
M       lustre/obdfilter/filter_log.c
M       lustre/obdfilter/filter_lvb.c
M       lustre/obdfilter/lproc_obdfilter.c
M       lustre/ptlrpc/wirehdr.c
M       lustre/ptlrpc/wiretest.c
CHANGES:
Index: libcfs/include/libcfs/linux/kp30.h
===================================================================
--- libcfs/include/libcfs/linux/kp30.h	(revision 31312)
+++ libcfs/include/libcfs/linux/kp30.h	(working copy)
@@ -38,9 +38,12 @@
 #define __LIBCFS_LINUX_KP30_H__
 
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
-# include <linux/config.h>
+#include <linux/config.h>
 #endif
+#endif
 #include <linux/kernel.h>
 #include <linux/mm.h>
 #include <linux/string.h>
@@ -59,7 +62,6 @@
 #include <linux/interrupt.h>
 #include <linux/highmem.h>
 #include <linux/module.h>
-#include <linux/version.h>
 #ifdef HAVE_LINUX_KERNEL_LOCK
 #include <linux/smp_lock.h>
 #endif
Index: libcfs/include/libcfs/linux/linux-prim.h
===================================================================
--- libcfs/include/libcfs/linux/linux-prim.h	(revision 31312)
+++ libcfs/include/libcfs/linux/linux-prim.h	(working copy)
@@ -49,13 +49,15 @@
 #error This include is only for kernel use.
 #endif
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/init.h>
 #include <linux/kernel.h>
-#include <linux/version.h>
 #include <linux/proc_fs.h>
 #include <linux/mm.h>
 #include <linux/timer.h>
Index: libcfs/include/libcfs/linux/linux-time.h
===================================================================
--- libcfs/include/libcfs/linux/linux-time.h	(revision 31312)
+++ libcfs/include/libcfs/linux/linux-time.h	(working copy)
@@ -98,12 +98,14 @@
 #error This include is only for kernel use.
 #endif
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/kernel.h>
-#include <linux/version.h>
 #include <linux/time.h>
 #include <asm/div64.h>
 
Index: libcfs/libcfs/linux/linux-debug.c
===================================================================
--- libcfs/libcfs/linux/linux-debug.c	(revision 31312)
+++ libcfs/libcfs/linux/linux-debug.c	(working copy)
@@ -42,9 +42,12 @@
 # define EXPORT_SYMTAB
 #endif
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/kmod.h>
 #include <linux/notifier.h>
@@ -66,7 +69,6 @@
 #include <linux/stat.h>
 #include <asm/uaccess.h>
 #include <linux/miscdevice.h>
-#include <linux/version.h>
 
 # define DEBUG_SUBSYSTEM S_LNET
 
Index: libcfs/libcfs/linux/linux-prim.c
===================================================================
--- libcfs/libcfs/linux/linux-prim.c	(revision 31312)
+++ libcfs/libcfs/linux/linux-prim.c	(working copy)
@@ -35,9 +35,12 @@
  */
 
 #define DEBUG_SUBSYSTEM S_LNET
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/fs_struct.h>
Index: libcfs/libcfs/linux/linux-proc.c
===================================================================
--- libcfs/libcfs/linux/linux-proc.c	(revision 31312)
+++ libcfs/libcfs/linux/linux-proc.c	(working copy)
@@ -44,9 +44,12 @@
 # define EXPORT_SYMTAB
 #endif
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/mm.h>
Index: lnet/klnds/gnilnd/gnilnd.h
===================================================================
--- lnet/klnds/gnilnd/gnilnd.h	(revision 31312)
+++ lnet/klnds/gnilnd/gnilnd.h	(working copy)
@@ -26,9 +26,12 @@
 #ifndef EXPORT_SYMTAB
 # define EXPORT_SYMTAB
 #endif
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/mm.h>
Index: lnet/klnds/mxlnd/mxlnd.h
===================================================================
--- lnet/klnds/mxlnd/mxlnd.h	(revision 31312)
+++ lnet/klnds/mxlnd/mxlnd.h	(working copy)
@@ -44,9 +44,12 @@
 #ifndef EXPORT_SYMTAB
 #define EXPORT_SYMTAB
 #endif
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>       /* module */
 #include <linux/kernel.h>       /* module */
 #include <linux/mm.h>
Index: lnet/klnds/o2iblnd/o2iblnd.h
===================================================================
--- lnet/klnds/o2iblnd/o2iblnd.h	(revision 31312)
+++ lnet/klnds/o2iblnd/o2iblnd.h	(working copy)
@@ -41,9 +41,12 @@
 #ifndef EXPORT_SYMTAB
 # define EXPORT_SYMTAB
 #endif
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/mm.h>
Index: lnet/klnds/ptllnd/ptllnd.h
===================================================================
--- lnet/klnds/ptllnd/ptllnd.h	(revision 31312)
+++ lnet/klnds/ptllnd/ptllnd.h	(working copy)
@@ -41,9 +41,12 @@
 #ifndef EXPORT_SYMTAB
 # define EXPORT_SYMTAB
 #endif
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/mm.h>
Index: lnet/klnds/qswlnd/qswlnd.h
===================================================================
--- lnet/klnds/qswlnd/qswlnd.h	(revision 31312)
+++ lnet/klnds/qswlnd/qswlnd.h	(working copy)
@@ -46,9 +46,12 @@
 
 #include <qsnet/kernel.h>
 #undef printf                                   /* nasty QSW #define */
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 
 #include <elan/epcomms.h>
Index: lnet/klnds/ralnd/ralnd.h
===================================================================
--- lnet/klnds/ralnd/ralnd.h	(revision 31312)
+++ lnet/klnds/ralnd/ralnd.h	(working copy)
@@ -41,9 +41,12 @@
 #ifndef EXPORT_SYMTAB
 # define EXPORT_SYMTAB
 #endif
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/mm.h>
Index: lnet/klnds/socklnd/socklnd_lib-linux.h
===================================================================
--- lnet/klnds/socklnd/socklnd_lib-linux.h	(revision 31312)
+++ lnet/klnds/socklnd/socklnd_lib-linux.h	(working copy)
@@ -42,12 +42,14 @@
 #ifndef __LINUX_SOCKNAL_LIB_H__
 #define __LINUX_SOCKNAL_LIB_H__
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/kernel.h>
-#include <linux/version.h>
 #include <linux/mm.h>
 #include <linux/string.h>
 #include <linux/stat.h>
Index: lustre/include/linux/lprocfs_status.h
===================================================================
--- lustre/include/linux/lprocfs_status.h	(revision 31312)
+++ lustre/include/linux/lprocfs_status.h	(working copy)
@@ -47,12 +47,14 @@
 #endif
 
 #ifdef __KERNEL__
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/proc_fs.h>
 #include <linux/seq_file.h>
-#include <linux/version.h>
 #include <linux/smp.h>
 #include <linux/rwsem.h>
 #include <libcfs/libcfs.h>
Index: lustre/include/linux/obd_support.h
===================================================================
--- lustre/include/linux/obd_support.h	(revision 31312)
+++ lustre/include/linux/obd_support.h	(working copy)
@@ -42,9 +42,12 @@
 #endif
 
 #ifdef __KERNEL__
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/seq_file.h>
 #include <linux/module.h>
 #include <linux/slab.h>
Index: lustre/llite/llite_mmap.c
===================================================================
--- lustre/llite/llite_mmap.c	(revision 31312)
+++ lustre/llite/llite_mmap.c	(working copy)
@@ -37,9 +37,12 @@
  * Lustre is a trademark of Sun Microsystems, Inc.
  */
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/kernel.h>
 #include <linux/mm.h>
 #include <linux/string.h>
@@ -49,7 +52,6 @@
 #include <linux/smp_lock.h>
 #endif
 #include <linux/unistd.h>
-#include <linux/version.h>
 #include <asm/system.h>
 #include <asm/uaccess.h>
 
Index: lustre/llite/lloop.c
===================================================================
--- lustre/llite/lloop.c	(revision 31312)
+++ lustre/llite/lloop.c	(working copy)
@@ -82,9 +82,12 @@
  *
  */
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 
 #include <linux/sched.h>
Index: lustre/llite/rw26.c
===================================================================
--- lustre/llite/rw26.c	(revision 31312)
+++ lustre/llite/rw26.c	(working copy)
@@ -41,9 +41,12 @@
  * Lustre Lite I/O page cache routines for the 2.5/2.6 kernel version
  */
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/kernel.h>
 #include <linux/mm.h>
 #include <linux/string.h>
@@ -53,7 +56,6 @@
 #include <linux/smp_lock.h>
 #endif
 #include <linux/unistd.h>
-#include <linux/version.h>
 #include <asm/system.h>
 #include <asm/uaccess.h>
 
Index: lustre/lvfs/lvfs_linux.c
===================================================================
--- lustre/lvfs/lvfs_linux.c	(revision 31312)
+++ lustre/lvfs/lvfs_linux.c	(working copy)
@@ -50,7 +50,6 @@
 #include <linux/slab.h>
 #include <linux/pagemap.h>
 #include <linux/quotaops.h>
-#include <linux/version.h>
 #include <libcfs/libcfs.h>
 #include <lustre_fsfilt.h>
 #include <obd.h>
Index: lustre/mdc/mdc_reint.c
===================================================================
--- lustre/mdc/mdc_reint.c	(revision 31312)
+++ lustre/mdc/mdc_reint.c	(working copy)
@@ -40,9 +40,12 @@
 #define DEBUG_SUBSYSTEM S_MDC
 
 #ifdef __KERNEL__
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
-# include <linux/config.h>
+#include <linux/config.h>
 #endif
+#endif
 # include <linux/module.h>
 # include <linux/kernel.h>
 #else
Index: lustre/mds/mds_log.c
===================================================================
--- lustre/mds/mds_log.c	(revision 31312)
+++ lustre/mds/mds_log.c	(working copy)
@@ -42,11 +42,13 @@
 
 #define DEBUG_SUBSYSTEM S_MDS
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
-#include <linux/version.h>
 
 #include <libcfs/list.h>
 #include <obd_class.h>
Index: lustre/mdt/mdt_identity.c
===================================================================
--- lustre/mdt/mdt_identity.c	(revision 31312)
+++ lustre/mdt/mdt_identity.c	(working copy)
@@ -47,9 +47,12 @@
 #endif
 #define DEBUG_SUBSYSTEM S_MDS
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/mm.h>
@@ -57,7 +60,6 @@
 #include <linux/string.h>
 #include <linux/stat.h>
 #include <linux/errno.h>
-#include <linux/version.h>
 #include <linux/unistd.h>
 #include <asm/system.h>
 #include <asm/uaccess.h>
Index: lustre/mdt/mdt_idmap.c
===================================================================
--- lustre/mdt/mdt_idmap.c	(revision 31312)
+++ lustre/mdt/mdt_idmap.c	(working copy)
@@ -44,9 +44,12 @@
 #endif
 #define DEBUG_SUBSYSTEM S_MDS
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/mm.h>
@@ -54,7 +57,6 @@
 #include <linux/string.h>
 #include <linux/stat.h>
 #include <linux/errno.h>
-#include <linux/version.h>
 #include <linux/unistd.h>
 #include <asm/system.h>
 #include <asm/uaccess.h>
Index: lustre/obdclass/linux/linux-module.c
===================================================================
--- lustre/obdclass/linux/linux-module.c	(revision 31312)
+++ lustre/obdclass/linux/linux-module.c	(working copy)
@@ -46,8 +46,11 @@
 #endif
 
 #ifdef __KERNEL__
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h> /* for CONFIG_PROC_FS */
+#include <linux/config.h>
+#endif /* for CONFIG_PROC_FS */
 #endif
 #include <linux/module.h>
 #include <linux/errno.h>
Index: lustre/obdfilter/filter.c
===================================================================
--- lustre/obdfilter/filter.c	(revision 31312)
+++ lustre/obdfilter/filter.c	(working copy)
@@ -54,14 +54,16 @@
 
 #define DEBUG_SUBSYSTEM S_FILTER
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/fs.h>
 #include <linux/dcache.h>
 #include <linux/init.h>
-#include <linux/version.h>
 #include <linux/sched.h>
 #include <linux/mount.h>
 #include <linux/buffer_head.h>
Index: lustre/obdfilter/filter_io.c
===================================================================
--- lustre/obdfilter/filter_io.c	(revision 31312)
+++ lustre/obdfilter/filter_io.c	(working copy)
@@ -42,12 +42,14 @@
 
 #define DEBUG_SUBSYSTEM S_FILTER
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/pagemap.h> // XXX kill me soon
-#include <linux/version.h>
 
 #include <obd_class.h>
 #include <obd_ost.h>
Index: lustre/obdfilter/filter_io_26.c
===================================================================
--- lustre/obdfilter/filter_io_26.c	(revision 31312)
+++ lustre/obdfilter/filter_io_26.c	(working copy)
@@ -43,12 +43,14 @@
  * Author: Phil Schwan <phil@clusterfs.com>
  */
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
 #include <linux/pagemap.h> // XXX kill me soon
-#include <linux/version.h>
 #include <linux/buffer_head.h>
 
 #define DEBUG_SUBSYSTEM S_FILTER
Index: lustre/obdfilter/filter_log.c
===================================================================
--- lustre/obdfilter/filter_log.c	(revision 31312)
+++ lustre/obdfilter/filter_log.c	(working copy)
@@ -42,11 +42,13 @@
 
 #define DEBUG_SUBSYSTEM S_FILTER
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
-#include <linux/version.h>
 
 #include <libcfs/list.h>
 #include <obd_class.h>
Index: lustre/obdfilter/filter_lvb.c
===================================================================
--- lustre/obdfilter/filter_lvb.c	(revision 31312)
+++ lustre/obdfilter/filter_lvb.c	(working copy)
@@ -42,11 +42,13 @@
 
 #define DEBUG_SUBSYSTEM S_FILTER
 
+#include <linux/version.h>
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 #ifndef AUTOCONF_INCLUDED
 #include <linux/config.h>
 #endif
+#endif
 #include <linux/module.h>
-#include <linux/version.h>
 
 #include <libcfs/list.h>
 #include <obd_class.h>
Index: lustre/obdfilter/lproc_obdfilter.c
===================================================================
--- lustre/obdfilter/lproc_obdfilter.c	(revision 31312)
+++ lustre/obdfilter/lproc_obdfilter.c	(working copy)
@@ -39,7 +39,6 @@
 #include <lprocfs_status.h>
 #include <obd.h>
 #include <linux/seq_file.h>
-#include <linux/version.h>
 
 #include "filter_internal.h"
 
Index: lustre/ptlrpc/wirehdr.c
===================================================================
--- lustre/ptlrpc/wirehdr.c	(revision 31312)
+++ lustre/ptlrpc/wirehdr.c	(working copy)
@@ -43,9 +43,12 @@
 #endif
 
 #ifdef __KERNEL__
+# include <linux/version.h>
+# if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 # ifndef AUTOCONF_INCLUDED
-#  include <linux/config.h>
+# include <linux/config.h>
 # endif
+# endif
 # ifdef CONFIG_FS_POSIX_ACL
 #  include <linux/fs.h>
 #  ifdef HAVE_XATTR_ACL
Index: lustre/ptlrpc/wiretest.c
===================================================================
--- lustre/ptlrpc/wiretest.c	(revision 31312)
+++ lustre/ptlrpc/wiretest.c	(working copy)
@@ -43,9 +43,12 @@
 #endif
 
 #ifdef __KERNEL__
+# include <linux/version.h>
+# if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
 # ifndef AUTOCONF_INCLUDED
-#  include <linux/config.h>
+# include <linux/config.h>
 # endif
+# endif
 # ifdef CONFIG_FS_POSIX_ACL
 #  include <linux/fs.h>
 #  ifdef HAVE_XATTR_ACL